<?php
/**
 * Copyright 2017 JMango360
 */

/**
 * Class Jmango360_Japi_Block_Checkout_Cart_Totals
 */
class Jmango360_Japi_Block_Checkout_Cart_Totals extends Mage_Checkout_Block_Cart_Totals
{
    protected function _getTotalRenderer($code)
    {
        $blockName = $code . '_total_renderer';

        if ($code == 'grand_total') {
            $newCode = 'grandtotal';
        } else {
            $newCode = $code;
        }

        try {
            $block = $this->getLayout()->createBlock("japi/checkout_total_{$newCode}", $blockName);
        } catch (Exception $e) {
            $block = null;
        }

        if (!$block) {
            $block = $this->_defaultRenderer;
            $config = Mage::getConfig()->getNode("global/sales/quote/totals/{$code}/renderer");
            if ($config) {
                $block = (string)$config;
            }

            $block = $this->getLayout()->createBlock($block, $blockName);
        }

        /**
         * Transfer totals to renderer
         */
        $block->setTotals($this->getTotals());

        return $block;
    }

    /**
     * Render totals html for specific totals area (footer, body)
     * Move discount row to bottom
     *
     * @param null|string $area
     * @param int $colspan
     * @return  string
     */
    public function renderTotalsV2($area = null, $colspan = 1)
    {
        $html = array();
        $discountHtml = '';

        foreach ($this->getTotals() as $total) {
            if ($total->getArea() != $area && $area != -1) {
                continue;
            }

            if ($total->getCode() == 'discount') {
                $discountHtml = $this->renderTotal($total, $area, $colspan);
            } else {
                $html[] = $this->renderTotal($total, $area, $colspan);
            }
        }

        $html[] = $discountHtml;

        return join('', $html);
    }
}
