<?php
/**
 * Copyright 2015 JMango360
 */
if (@class_exists('Kega_Checkout_Block_Onepage')) {
    include('Kega.php');
} elseif (Mage::helper('core')->isModuleEnabled('LaPoste_SoColissimoSimplicite') && @class_exists('LaPoste_SoColissimoSimplicite_Block_Onepage')) {
    include('LaPoste.php');
} elseif (@class_exists('Flagbit_Checkout_Block_Onepage')) {
    include('Flagbit.php');
} else {
    include('Jmango360.php');
}

class Jmango360_Japi_Block_Checkout_Onepage extends Jmango360_Japi_Block_Checkout_Onepage_Abstract
{
    public function getSteps()
    {
        $steps = parent::getSteps();

        if (Mage::helper('core')->isModuleEnabled('Flagbit_Checkout')) {
            foreach ($steps as $code => $step) {
                switch ($code) {
                    case 'billing':
                        $steps[$code]['label'] = $this->__('Personal Information');
                        break;
                    case 'payment':
                        $steps[$code]['label'] = $this->__('Payment &amp; Shipping');
                        break;
                    case 'review':
                        $steps[$code]['label'] = $this->__('Order confirmation');

                }
            }
        }

        return $steps;
    }

    /**
     * get checkout steps with step number
     */
    public function getStepsV2()
    {
        $steps = parent::getSteps();

        foreach ($steps as $code => $step) {
            switch ($code) {
                case 'billing':
                    $steps[$code]['number'] = 1;
                    $steps[$code]['label'] = Mage::helper('japi')->__('Billing Information');
                    break;
                case 'shipping':
                    $steps[$code]['number'] = 2;
                    $steps[$code]['label'] = Mage::helper('japi')->__('Shipping Address');
                    break;
                case 'shipping_method':
                    $steps[$code]['number'] = 3;
                    $steps[$code]['label'] = Mage::helper('japi')->__('Shipping Method');
                    break;
                case 'payment':
                    $steps[$code]['number'] = 4;
                    $steps[$code]['label'] = Mage::helper('japi')->__('Payment Information');
                    break;
                case 'review':
                    $steps[$code]['number'] = 5;
                    $steps[$code]['label'] = Mage::helper('japi')->__('Order Review');
            }
        }

        if (Mage::helper('core')->isModuleEnabled('Flagbit_Checkout')) {
            foreach ($steps as $code => $step) {
                switch ($code) {
                    case 'billing':
                        $steps[$code]['label'] = $this->__('Personal Information');
                        break;
                    case 'payment':
                        $steps[$code]['label'] = $this->__('Payment &amp; Shipping');
                        break;
                    case 'review':
                        $steps[$code]['label'] = $this->__('Order confirmation');

                }
            }
        }

        return $steps;
    }

    public function getCurrentStep()
    {
        $steps = $this->getStepsV2();

        if (parent::getActiveStep() && !in_array(parent::getActiveStep(), array('billing', 'login'))) {
            return $steps['billing'];
        } else if (Mage::getSingleton('core/session')->getData('is_billing_address_update')) {
            return $steps['billing'];
        } else if (Mage::getSingleton('core/session')->getData('is_shipping_address_update')) {
            return $steps['shipping'];
        } else if (Mage::helper('japi')->isAddressesReady()) {
            return $steps['shipping_method'];
        } else {
            return $steps['billing'];
        }
    }

    /**
     * Get checkout steps codes
     *
     * @return array
     * @throws
     */
    protected function _getStepCodes()
    {
        if (Mage::helper('core')->isModuleEnabled('MadeByMouses_Olifant')) {
            $isNotB2B = Mage::app()->getStore()->getCode() != 'wholesale';
            if (Mage::helper('customer')->isLoggedIn() && $isNotB2B) {
                return array('login', 'billing', 'shipping', 'olifant', 'shipping_method', 'payment', 'review');
            }
        }

        return parent::_getStepCodes();
    }
}