<?php
/**
 * Copyright 2018 JMango360
 */

/**
 * Support AW_Points Checkout Onepage Payment Methods
 */
class Jmango360_Japi_Block_Checkout_Onepage_Payment_Methods_Abstract extends AW_Points_Block_Checkout_Onepage_Payment_Methods
{
    /**
     * Render block HTML
     *
     * @return string
     */
    protected function _toHtml()
    {
        $quote = $this->getQuote();
        if (
            $quote->getBaseGrandTotal() == 0 &&
            $quote->hasBaseAwGiftCardsAmount() &&
            $this->_getBaseAwGiftCardAmount() != 0 &&
            ($quote->hasBaseMoneyForPoints() ? $quote->getBaseMoneyForPoints() : 0) === 0
        ) {
            return parent::_toHtml();
        }

        foreach ($quote->getAllItems() as $item) {
            if ($item->getIsRecurring()) {
                return parent::_toHtml();
            }
        }

        $magentoVersionTag = AW_Points_Helper_Data::MAGENTO_VERSION_14;
        if (Mage::helper('points')->magentoLess14()) {
            $magentoVersionTag = AW_Points_Helper_Data::MAGENTO_VERSION_13;
        }

        if (!in_array('japi_checkout_onepage', $this->getLayout()->getUpdate()->getHandles())) {
            $this->setTemplate('aw_points/checkout/onepage/payment/' . $magentoVersionTag . '/methods.phtml');
        } else {
            $this->setTemplate('aw_points/checkout/onepage/payment/info.phtml');
        }

        return Mage_Checkout_Block_Onepage_Payment_Methods::_toHtml();
    }
}