<?php
/**
 * Copyright 2021 JMango360
 */

/**
 * Class Jmango360_Japi_Helper_Hevelop_CSA_Data
 */
class Jmango360_Japi_Helper_Hevelop_CSA_Data extends Hevelop_ConfigurableSimpleAttributes_Helper_Data
{
    protected $apis = array(
        'japi/rest_cart/',
        'japi/rest_checkout/'
    );

    protected $paymentUrls = [
        1 => 'onepagecheckout',
        2 => 'formPayment/go',
        3 => 'aitcheckout',
        4 => 'onestepcheckout',
        5 => 'checkout/cart',
        6 => 'checkout/onepage',
        7 => 'paypal/express',
        8 => 'checkout/multishipping',
        9 => 'authorizenet/directpost_payment',
        10 => 'firecheckout',
        11 => 'onepage',
    ];

    /**
     * Check if string s1 contains string s2
     * OVERRIDE: Bypass JMango360's APIs
     *
     * @param $s1
     * @param $s2
     * @return bool
     */
    public function strContains($s1, $s2)
    {
        if (in_array($s2, $this->paymentUrls)) {
            foreach ($this->apis as $api) {
                if (strpos($s1, $api) !== false) {
                    return true;
                }
            }
        }

        return parent::strContains($s1, $s2);
    }
}