<?php

/**
 * Copyright 2015 JMango360
 */
class Jmango360_Japi_Helper_Product_File_Amasty extends Mage_Core_Helper_Abstract
{
    /**
     * @param Mage_Catalog_Model_Product $product
     * @return null|array
     * @throws
     */
    public function getItems($product)
    {
        if (!$product->getId()) return null;

        $storeId = Mage::app()->getStore()->getStoreId();
        $files = Mage::getResourceModel('amfile/file_collection')->getFilesFrontend($product->getId(), $storeId);

        $result = array(
            'label' => Mage::getStoreConfig('amfile/block/title'),
            'items' => array()
        );
        foreach ($files as $file) {
            /** @var Amasty_File_Model_File $file */
            $item = array(
                'name' => $file->title(),
                'url' => $file->getFileUrl() ? Mage::getUrl('amfile_front/file/download', array('file_id' => $file->getId())) : $file->getFileLink(),
                'icon' => $file->getIcon(),
                'size' => $file->getFullFileSize(),
                'description' => ''
            );

            $result['items'][] = $item;
        }

        return $result;
    }
}