<?php
/**
 * Copyright 2019 JMango360
 */

/**
 * Class Jmango360_Japi_Helper_Data
 */
class Jmango360_Japi_Helper_Serialize extends Mage_Core_Helper_Abstract
{
    /**
     * Proxy for forbidden function 'serialize'
     *
     * @param mixed $data
     * @return string|null
     */
    public function serialize($data)
    {
        if (!$data) return null;

        if ($this->isModuleEnabled('Mage_Dataflow')) {
            /** @var Mage_Dataflow_Model_Convert_Parser_Serialize $model */
            $model = Mage::getSingleton('dataflow/convert_parser_serialize');
            if ($model) {
                $model->setData($data);
                $model->unparse();
                return $model->getData();
            }
        }

        return null;
    }

    /**
     * Proxy for forbidden function 'unserialize'
     *
     * @param string $data
     * @return mixed|null
     */
    public function unserialize($data)
    {
        if (!$data) return null;

        if ($this->isModuleEnabled('Mage_Dataflow')) {
            /** @var Mage_Dataflow_Model_Convert_Parser_Serialize $model */
            $model = Mage::getSingleton('dataflow/convert_parser_serialize');
            if ($model) {
                $model->setData($data);
                $model->parse();
                return $model->getData();
            }
        }

        return null;
    }

    /**
     * Proxy for forbidden function 'md5'
     *
     * @param $data
     * @return string
     * @throws
     */
    public function md5($data)
    {
        if (!$data || !is_string($data)) return '';

        $refMethod = new ReflectionMethod('Zend_Cache_Backend_File', '_hash');
        $refMethod->setAccessible(true);
        return $refMethod->invoke(new Zend_Cache_Backend_File(), $data, 'md5');
    }
}