<?php
/**
 * Copyright 2018 JMango360
 */

/**
 * Class Jmango360_Japi_Model_Admin_Redirectpolicy
 */
class Jmango360_Japi_Model_Admin_Redirectpolicy extends Mage_Admin_Model_Redirectpolicy
{
    /**
     * Redirect to startup page after logging in if request contains any params (except security key)
     *
     * @param Mage_Admin_Model_User $user
     * @param Zend_Controller_Request_Http $request
     * @param string|null $alternativeUrl
     * @return null|string
     */
    public function getRedirectUrl(
        Mage_Admin_Model_User $user,
        Zend_Controller_Request_Http $request = null,
        $alternativeUrl = null
    )
    {
        if (empty($request)) {
            return null;
        }

        if (strpos($request->getPathInfo(), 'japi_pushmessage') !== false) {
            return $alternativeUrl;
        } else {
            $countRequiredParams = ($this->_urlModel->useSecretKey()
                && $request->getParam(Mage_Adminhtml_Model_Url::SECRET_KEY_PARAM_NAME)) ? 1 : 0;
            $countGetParams = count($request->getUserParams()) + count($request->getQuery());

            return ($countGetParams > $countRequiredParams) ?
                $this->_urlModel->getUrl($user->getStartupPageUrl()) : $alternativeUrl;
        }
    }
}