<?php
/**
 * Copyright 2019 JMango360
 */

/**
 * Mage core session abstract overwrite to bypass session validate
 */
class Jmango360_Japi_Model_Core_Dummy extends Mage_Core_Model_Session_Abstract
{
    /**
     * Validate session
     * Just return TRUE
     */
    public function validate()
    {
        return $this;
    }

    /**
     * @return Jmango360_Japi_Model_Core_Cookie
     */
    public function getCookie()
    {
        return Mage::getSingleton('japi/core_cookie');
    }

    /**
     * Check whether SID can be used for session initialization
     * Admin area will always have this feature enabled
     * Always enabled with 'japi' routers
     *
     * @return bool
     */
    public function useSid()
    {
        return true;
    }
}
