<?php
if (Mage::helper('core')->isModuleEnabled('Flagbit_LanguageSelector') && @class_exists('Flagbit_LanguageSelector_Model_Observer')) {
    class Jmango360_Japi_Model_Flagbit_LanguageSelector_Observer extends Flagbit_LanguageSelector_Model_Observer
    {
        public function redirectByBrowserLang($observe)
        {
            if ($this->_japiBypass($observe)) {
                return;
            }

            parent::redirectByBrowserLang($observe);
        }

        public function syncCookieWithSession($observe)
        {
            if ($this->_japiBypass($observe)) {
                return;
            }

            parent::syncCookieWithSession($observe);
        }

        protected function _getStoreToRedirect()
        {
            if (Mage::app()->getRequest()->getModuleName() == 'japi') {
                return Mage::app()->getStore();
            }
            return parent::_getStoreToRedirect();
        }

        /**
         * @param Varien_Event_Observer $observe
         * @return bool
         */
        protected function _japiBypass($observe)
        {
            /** @var Mage_Core_Controller_Varien_Action $action */
            $action = $observe->getEvent()->getControllerAction();
            $moduleName = $action->getRequest()->getModuleName();
            if ($moduleName == 'japi') {
                $actionName = $action->getRequest()->getActionName();
                $shippingCountryHeader = $action->getRequest()->getHeader('Japi-Shipping-Country');
                /** @var Flagbit_LanguageSelector_Helper_Data $helper */
                $helper = Mage::helper('languageselector');

                /**
                 * Apply shipping country from API header
                 */
                if ($shippingCountryHeader && $helper->getCurrentShippingCountry() !== $shippingCountryHeader) {
                    $helper->setQuoteShippingCountry($shippingCountryHeader);
                }

                /**
                 * Set shipping country to cookie to make checkout functioning
                 */
                if ($actionName == 'redirect') {
                    $this->setCountryCookieOnCheckout();
                }

                /**
                 * The onepage checkout page should run as others
                 */
                if ($actionName == 'onepage') {
                    return false;
                }

                return true;
            } elseif ($moduleName == 'adyen') {
                return true;
            }
        }
    }
} else {
    include('Observer_Jmango360.php');
}