<?php
/**
 * Copyright 2018 JMango360
 * User: i4cu
 * Date: 6/5/18
 * Time: 10:33 AM
 */

/**
 * Class Jmango360_Japi_Model_Observer_Catalog_Category
 */
class Jmango360_Japi_Model_Observer_Catalog_Product
{
    public function banProductCache($event)
    {
        /* @var Jmango360_Japi_Helper_Data $japiHelper */
        $japiHelper = Mage::helper('japi');
        if ($japiHelper->isModuleEnabled('Nexcessnet_Turpentine')
            && Mage::helper('turpentine/varnish')->getVarnishEnabled()) {
            $product = $event->getProduct();
            $urlPattern = $this->getProductApiRequest($product);
            $japiHelper->_getVarnishAdmin()->flushUrl($urlPattern);
        }
    }

    public function banProductReviewCaches($event) {
        /* @var Jmango360_Japi_Helper_Data $japiHelper */
        $japiHelper = Mage::helper('japi');
        if ($japiHelper->isModuleEnabled('Nexcessnet_Turpentine')
            && Mage::helper('turpentine/varnish')->getVarnishEnabled()) {
            $urlPatterns = array();
            /* @var $review \Mage_Review_Model_Review*/
            $review = $event->getObject();

            /* @var $productCollection \Mage_Review_Model_Resource_Review_Product_Collection*/
            $productCollection = $review->getProductCollection();

            $products = $productCollection->addEntityFilter((int) $review->getEntityPkValue())->getItems();

            foreach ($products as $product) {
                $productId = $product->getEntityId();
                $urlPatterns[] = './japi/rest_product/getReviews\?product_id=' . $productId . '.';
            }

            $pattern = sprintf('(?:%s)', implode('|', $urlPatterns));
            $japiHelper->_getVarnishAdmin()->flushUrl($pattern);
        }
    }

    /**
     * @param Mage_Catalog_Model_Product $product
     * @return string
     */
    protected function getProductApiRequest($product) {
        $urlPatterns = array();
        $productRegex ='.detail\?product_id=';
        /* @var $productHelper Jmango360_Japi_Helper_Product */
        $productHelper = Mage::helper('japi/product');
        foreach ($productHelper->getParentProducts($product) as $parentProduct) {
            $urlPatterns[] = $productRegex . $parentProduct->getId() . '.';
        }

        $urlPatterns[] = $productRegex . $product->getId() . '.';

        //We also need to purge product list, and up-sell, cross-sell, related products
        $urlPatterns[] = './japi/rest_product/list.';
        $urlPatterns[] = './japi/rest_product/getRelated.';
        $urlPatterns[] = './japi/rest_product/getUpSell.';
        $urlPatterns[] = './japi/rest_product/getCrossSell.';

        if (empty($urlPatterns)) {
            $urlPatterns[] = "##_NEVER_MATCH_##";
        }
        $pattern = sprintf('(?:%s)', implode('|', $urlPatterns));
        return $pattern;
    }
}