<?php

class Jmango360_Japi_Model_Rest_Catalog_Category_Tree_V2 extends Jmango360_Japi_Model_Rest_Catalog_Category_Tree
{
    /**
     * The childlevels are restricted to two levels
     * -- Menu-item1
     * -- -- Menu sub-item1
     * -- -- Menu sub-item2
     * -- Menu-item2
     * -- -- Menu sub-item1
     * (adjust MAXTREEDEPTH to get more tree depth)
     */
    protected function _getActiveMenuTree($categories, $indexLevel = 1)
    {
        $maxTreeDepth = Mage::helper('japi')->getRequest()->getParam('max_tree_depth', null);
        if (is_null($maxTreeDepth)) {
            $maxTreeDepth = self::MAXTREEDEPTH;
        }

        $data = array();
        $index = 0;
        foreach ($categories as $category) {
            /* @var $category Mage_Catalog_Model_Category */
            if ($this->isCategoryEmpty($category)) continue;

            $data[$index] = $category->getData();
            $data[$index]['thumbnail'] = $this->_getThumbnailUrl($category);
            $data[$index]['image'] = $this->_getImageUrl($category);
            //Backwards compatibility
            $data[$index]['category_id'] = $data[$index]['entity_id'];
            $data[$index]['children'] = array();

            $childrenCategories = $this->_getMenuChildren($category);
            if ($childrenCategories && $childrenCategories->count() && $indexLevel < $maxTreeDepth) {
                $indexLevel++;
                $data[$index]['children'] = $this->_getActiveMenuTree($childrenCategories, $indexLevel);
                --$indexLevel;
            }

            $index++;
        }

        return $data;
    }

    /**
     * Check if category dont have children and products
     *
     * @param Mage_Catalog_Model_Category $category
     * @return bool
     */
    protected function isCategoryEmpty($category)
    {
        return !$category->hasChildren() && !$category->getProductCount();
    }
}