<?php
/**
 * Copyright 2018 JMango360
 */

/**
 * Class Jmango360_Japi_Model_Varnish_Configurator_Version4
 */
class Jmango360_Japi_Model_Varnish_Configurator_Version4
    extends Nexcessnet_Turpentine_Model_Varnish_Configurator_Version4
{
    /**
     * Build the list of template variables to apply to the VCL template
     *
     * @return array
     */
    protected function _getTemplateVars()
    {
        $vars = parent::_getTemplateVars();

        if (Mage::getStoreConfigFlag('japi/jmango_rest_developer_settings/enable_varnish')) {
            $vars['normalize_host'] = isset($vars['normalize_host'])
                ? $vars['normalize_host'] . $this->_getAdditionalVclRecv()
                : $this->_getAdditionalVclRecv();

            $vars['custom_vcl_include'] = isset($vars['custom_vcl_include'])
                ? $vars['custom_vcl_include'] . $this->_getAdditionalVclConfig()
                : $this->_getAdditionalVclConfig();
        }

        return $vars;
    }

    /**
     * Return additional vcl_recv config
     */
    protected function _getAdditionalVclRecv()
    {
        return <<<EOS
if (req.url ~ "/japi/rest_"){
    if (req.url ~ "(.*)(SID=([^&]+))(.*)") {
        set req.http.Cookie = regsub(req.url, "(.*)(SID=([^&]+))(.*)", "frontend=\\3");
        set req.http.JM360-SID = regsub(req.url, "(.*)(SID=([^&]+))(.*)", "\\3");
        set req.url = regsub(req.url, "(.*)(SID=([^&]+))(.*)", "\\1SID=JM360SID\\4");
    }
    if (req.url ~ "(.*)(token=([^&]+))(.*)") {
        set req.url = regsub(req.url, "(.*)(token=([^&]+))(.*)", "\\1\\4");
    }
    return (hash);
}
if (req.url ~ "/japi/customer" || req.url ~ "/japi/checkout" || req.url ~ "/japi/rest_mage/redirect"){
    return (pipe);
}
EOS;
    }

    /**
     * Return additional vcl_backend_fetch config
     */
    protected function _getAdditionalVclConfig()
    {
        return <<<EOS
sub vcl_backend_fetch {
    if (bereq.http.JM360-SID){
        set bereq.url = regsub(bereq.url, "JM360SID", bereq.http.JM360-SID);
    }
}
EOS;
    }
}