<?php

class Jmango360_Japi_Rest_MageController extends Jmango360_Japi_Controller_Abstract
{
    public function storeAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getSessionAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getTokenAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getMagentoInfoAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getPluginVersionAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getConfigInfoAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getDirectoryCountryListAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getDirectoryRegionListAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getMagentoModulesAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getModuleRewritesAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function updateThemeAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getThemeAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function redirectAction()
    {
        /* @var $helper Jmango360_Japi_Helper_Data */
        $helper = Mage::helper('japi');

        /**
         * MPLUGIN-1377: Reset PHPSESSID
         */
        $helper->checkValidSession();

        $helper->injectCookies();

        /**
         * MPLUGIN-1126: by pass check user's IP adress to auto redirect when website installed "Experius_Geoipredirect"
         */
        if ($helper->isModuleEnabled('Experius_Geoipredirect')) {
            Mage::getSingleton('core/session')->setData('ipcheck_redirected', Mage::app()->getStore()->getId());
        }

        $url = urldecode(urldecode($this->getRequest()->getParam('url')));

        /**
         * MPLUGIN-2279: Workaround for Flagbit_LanguageSelector and GGM
         */
        if ($helper->isModuleEnabled('Flagbit_LanguageSelector')) {
            $storeCode = Mage::app()->getStore()->getCode();
            if (strpos($url, '?') !== false) {
                $url .= '&___store=' . $storeCode;
            } else {
                $url .= '?___store=' . $storeCode;
            }
        }

        /**
         * MPLUGIN-2655: workaround to disable MageWorx_StoreSwitcher in our request
         */
        if ($helper->isModuleEnabled('MageWorx_StoreSwitcher')) {
            $storeCode = Mage::app()->getStore()->getCode();
            $disableKeyword = Mage::getStoreConfig('mageworx_geoip/mageworx_storeswitcher/disable_store_switcher_key');
            if (strpos($url, '?') !== false) {
                $url .= '&' . $disableKeyword . '&___store=' . $storeCode;
            } else {
                $url .= '?' . $disableKeyword . '&___store=' . $storeCode;
            }
        }

        /** @var Jmango360_Japi_Model_Core_Cookie $cookie */
        $cookie = Mage::getSingleton('japi/core_cookie');

        /**
         * MPLUGIN-2933: workaround to fix cookie injection for mtools.nl only
         */
        if (strpos(Mage::getBaseUrl(), 'mtools.nl') !== false) {
            $cookie->set('frontend', Mage::app()->getRequest()->getParam('SID'));
        }

        /**
         * Clean session
         */
        $helper->clearPreviousFlags();

        /**
         * Redirect
         */
        if (strpos($url, 'http') === 0) {
            $this->_redirectUrl($url);
        } else {
            $this->_redirect($url, array('_secure' => true));
        }
    }

    public function ordersAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function eventsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getSettingsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getSettingAttributesAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getShippingAndPaymentMethodsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function getAllSystemSettingsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function saveSettingsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function checkSettingsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }

    public function clearStoreScopeSettingsAction()
    {
        $server = $this->getServer();
        $server->setRestDispatchModel(Mage::getModel('japi/rest_mage'));
        $server->run();
    }
}