/**
 * Copyright 2015 JMango360
 */

if (!window.toogleVisibilityOnObjects) {
    var toogleVisibilityOnObjects = function (source, objects) {
        if ($(source) && $(source).checked) {
            objects.each(function (item) {
                if ($(item)) {
                    $(item).show();
                    $$('#' + item + ' .input-text').each(function (item) {
                        item.removeClassName('validation-passed');
                    });
                }
            });
        } else {
            objects.each(function (item) {
                if ($(item)) {
                    $(item).hide();
                    $$('#' + item + ' .input-text').each(function (sitem) {
                        sitem.addClassName('validation-passed');
                    });
                    $$('#' + item + ' .giftmessage-area').each(function (sitem) {
                        sitem.value = '';
                    });
                    $$('#' + item + ' .checkbox').each(function (sitem) {
                        sitem.checked = false;
                    });
                    $$('#' + item + ' .select').each(function (sitem) {
                        sitem.value = '';
                    });
                    $$('#' + item + ' .price-box').each(function (sitem) {
                        sitem.addClassName('no-display');
                    });
                }
            });
        }
    }
}

if (!window.toogleVisibility) {
    var toogleVisibility = function (objects, show) {
        objects.each(function (item) {
            if ($(item)) {
                if (show) {
                    $(item).show();
                    $(item).removeClassName('no-display');
                } else {
                    $(item).hide();
                    $(item).addClassName('no-display');
                }
            }
        });
    }
}

if (!window.toogleRequired) {
    var toogleRequired = function (source, objects) {
        if (!$(source).value.blank()) {
            objects.each(function (item) {
                $(item) && $(item).addClassName('required-entry');
            });
        } else {
            objects.each(function (item) {
                if (typeof shippingMethod != 'undefined' && shippingMethod.validator) {
                    shippingMethod.validator.reset(item);
                }
                $(item) && $(item).removeClassName('required-entry');
            });
        }
    }
}

if (!window.jm360CanGoBack) {
    var jm360CanGoBack = function () {
        var currentStep = jQuery('#checkout-navbar .steps .step.active');
        if (currentStep.length) {
            var prevStep = currentStep.prev();
            return !!prevStep.length;
        }
    };
}

if (!window.jm360GoBack) {
    var jm360GoBack = function () {
        var currentStep = jQuery('#checkout-navbar .steps .step.active');
        if (currentStep.length) {
            var prevStep = currentStep.prev();
            if (prevStep.length) {
                checkout.gotoSection(prevStep.data('step'));
            }
        }
    };
}

if (typeof Checkout !== "undefined") {
    var JMCheckout = Class.create(Checkout, {
        initialize: function (accordion, urls) {
            this.accordion = accordion;
            this.progressUrl = urls.progress;
            this.reviewUrl = urls.review;
            this.saveMethodUrl = urls.saveMethod;
            this.failureUrl = urls.failure;
            this.shippingMethodUrl = urls.shippingMethodUrl;
            this.editAddressUrl = urls.editAddressUrl;
            this.billingForm = false;
            this.shippingForm = false;
            this.syncBillingShipping = false;
            this.method = 'guest';
            this.payment = '';
            this.loadWaiting = false;
            this.steps = ['billing', 'shipping', 'shipping_method', 'payment', 'review'];
            //We use billing as beginning step since progress bar tracks from billing
            this.currentStep = 'billing';
            this.redirectUrl = '';

            if ($('register-customer-password')) {
                Element.hide('register-customer-password');
            }

            ['billing', 'shipping'].each(function (section) {
                /**
                 * Fix site with double #ID, you evil.
                 */
                if ($$('#' + section + '-buttons-container').length) {
                    $$('#' + section + '-buttons-container').each(function (buttonsSection) {
                        $(buttonsSection).select('button').each(function (button) {
                            $(button).setAttribute('id', section + '-button');
                            this.getLaddaButton(button);
                        }.bind(this));
                    }.bind(this));
                }
            }.bind(this));

            /**
             * Kega_Checkout: Bind some shortcut links
             */
            document.on('click', '#edit-billing-address', function () {
                this.gotoSection('billing');
            }.bind(this));
            document.on('click', '#edit-shipping-address', function () {
                this.gotoSection('billing');
            }.bind(this));
            document.on('click', '#edit-shipping-method', function () {
                this.gotoSection('shipping_method');
            }.bind(this));

            document.on('click', '.japi-address-edit-btn', function (e, btn) {
                this.gotoEditAddress(btn);
            }.bind(this))
        },

        /**
         * Scroll to element (jQuery)
         *
         * @param id
         */
        scrollTo: function (id) {
            var top = JMango(id).offset().top;
            if (typeof scrollTo === 'function') {
                scrollTo(top);
            } else {
                JMango('html, body').animate({
                    scrollTop: top
                });
            }
        },

        gotoEditAddress: function (btn) {
            var addressSelect = $(btn).up('form').down('select.address-select');
            if (addressSelect) {
                var type;
                if (addressSelect.getAttribute('name').indexOf('billing') > -1) {
                    type = 'billing';
                } else if (addressSelect.getAttribute('name').indexOf('shipping') > -1) {
                    type = 'shipping';
                }
                var addressId = addressSelect.getValue();
                if (addressId) {
                    var url = this.editAddressUrl;
                    if (url.indexOf('?') > -1) {
                        url += '&';
                    } else {
                        url += '?';
                    }
                    window.location.href = url + 'id=' + addressId + '&is_checkout=1&type=' + type;
                }
            }
        },

        /**
         * Deprecated
         *
         * @param step
         * @param keepDisabled
         */
        _setLoadWaiting_: function (step, keepDisabled) {
            var btn;
            if (step) {
                if (this.loadWaiting) {
                    this.setLoadWaiting(false);
                }
                btn = this.getLaddaButton(step);
                btn && btn.start();
            } else {
                if (this.loadWaiting) {
                    if (!keepDisabled) {
                        btn = this.getLaddaButton(this.loadWaiting);
                        btn && btn.stop();
                    }
                }
            }
            this.loadWaiting = step;
        },

        setLoadWaiting: function (step, keepDisabled) {
            if (step) {
                this.showSpinner(true);
            } else {
                this.showSpinner(false);
            }
        },

        showSpinner: function (flag) {
            var spinner = this.getFullScreenSpinner(),
                overlay = document.getElementById('fullScreenSpinnerOverlay'),
                target = document.getElementById('fullScreenSpinner');

            if (!spinner || !overlay || !target) return;

            if (flag) {
                spinner && spinner.spin(target);
                overlay.style.display = 'block';
            } else {
                overlay.style.display = 'none';
                spinner && spinner.stop();
            }
        },

        getFullScreenSpinner: function () {
            if (!this.spinner && typeof Spinner !== "undefined") {
                this.spinner = new Spinner({
                    lines: 12, // The number of lines to draw
                    length: 0, // The length of each line
                    width: 10, // The line thickness
                    radius: 26, // The radius of the inner circle
                    scale: 1, // Scales overall size of the spinner
                    corners: 1, // Corner roundness (0..1)
                    color: '#ffffff', // CSS color or array of colors
                    fadeColor: 'transparent', // CSS color or array of colors
                    speed: 1, // Rounds per second
                    rotate: 0, // The rotation offset
                    animation: 'spinner-line-fade-quick', // The CSS animation name for the lines
                    direction: 1, // 1: clockwise, -1: counterclockwise
                    zIndex: 2e9, // The z-index (defaults to 2000000000)
                    className: 'spinner', // The CSS class to assign to the spinner
                    top: '50%', // Top position relative to parent
                    left: '50%', // Left position relative to parent
                    shadow: '', // Box-shadow for the lines
                    position: 'absolute' // Element positioning
                });
            }

            return this.spinner;
        },

        getLaddaButton: function (el) {
            if (!el) return;
            var $el;
            if (typeof el == 'string') {
                //$el = $$('#' + el + '-buttons-container button')[0];
                //$el = $('submit-' + el);
            } else {
                $el = $(el);
            }
            if (!$el) return;
            if ($el.ladda) return $el.ladda;
            $el.addClassName('ladda-button');
            if (!$el.getAttribute('data-color')) $el.setAttribute('data-color', 'jmango');
            if (!$el.getAttribute('data-style')) $el.setAttribute('data-style', 'slide-up');
            if (!$el.getAttribute('data-size')) $el.setAttribute('data-size', '0');
            return $el.ladda = Ladda.create($el);
        },

        reloadProgressBlock: function (toStep) {

        },

        gotoSection: function (section, reloadProgressBlock) {
            this.hideAllStepLabels();
            switch (section) {
                case 'billing':
                    billing.renderAddressList(store.get('billing_addresses'), 'billing');

                    jQuery('#navbar-step1').addClass('active').removeClass('old');
                    $('opc-billing').show();
                    $('checkout-step-billing').show();
                    jQuery('#navbar-title1').show();

                    jQuery('#navbar-step2').removeClass('active').removeClass('old');
                    $('opc-shipping').hide();
                    $('checkout-step-shipping').hide();

                    jQuery('#navbar-step3').removeClass('active').removeClass('old');
                    $('opc-shipping_method').hide();
                    $('checkout-step-shipping_method').hide();

                    jQuery('#navbar-step4').removeClass('active').removeClass('old');
                    $('opc-payment').hide();
                    $('checkout-step-payment').hide();

                    jQuery('#navbar-step5').removeClass('active').removeClass('old');
                    $('opc-review').hide();
                    $('checkout-step-review').hide();

                    break;
                case 'shipping':
                    shipping.renderAddressList(store.get('shipping_addresses'), 'shipping');

                    jQuery('#navbar-step1').addClass('old').removeClass('active');
                    $('opc-billing').hide();
                    $('checkout-step-billing').hide();

                    jQuery('#navbar-step2').addClass('active').removeClass('old');
                    $('opc-shipping').show();
                    $('checkout-step-shipping').show();
                    jQuery('#navbar-title2').show();

                    jQuery('#navbar-step3').removeClass('active').removeClass('old');
                    $('opc-shipping_method').hide();
                    $('checkout-step-shipping_method').hide();

                    jQuery('#navbar-step4').removeClass('active').removeClass('old');
                    $('opc-payment').hide();
                    $('checkout-step-payment').hide();

                    jQuery('#navbar-step5').removeClass('active').removeClass('old');
                    $('opc-review').hide();
                    $('checkout-step-review').hide();

                    /**
                     * MPLUGIN-3688: Scroll page to selected address or top
                     */
                    setTimeout(function () {
                        checkout.scrollTo('html');
                    });

                    break;
                case 'shipping_method':
                    jQuery('#navbar-step1').addClass('old').removeClass('active');
                    $('opc-billing').hide();
                    $('checkout-step-billing').hide();

                    jQuery('#navbar-step2').addClass('old').removeClass('active');
                    $('opc-shipping').hide();
                    $('checkout-step-shipping').hide();

                    jQuery('#navbar-step3').removeClass('old').addClass('active');
                    $('opc-shipping_method').show();
                    $('checkout-step-shipping_method').show();
                    jQuery('#navbar-title3').show();

                    jQuery('#navbar-step4').removeClass('active').removeClass('old');
                    $('opc-payment').hide();
                    $('checkout-step-payment').hide();

                    jQuery('#navbar-step5').removeClass('active').removeClass('old');
                    $('opc-review').hide();
                    $('checkout-step-review').hide();

                    setTimeout(function () {
                        checkout.scrollTo('html');
                    });

                    break;
                case 'payment':
                    jQuery('#navbar-step1').addClass('old').removeClass('active');
                    $('opc-billing').hide();
                    $('checkout-step-billing').hide();

                    jQuery('#navbar-step2').addClass('old').removeClass('active');
                    $('opc-shipping').hide();
                    $('checkout-step-shipping').hide();

                    jQuery('#navbar-step3').addClass('old').removeClass('active');
                    $('opc-shipping_method').hide();
                    $('checkout-step-shipping_method').hide();

                    jQuery('#navbar-step4').addClass('active').removeClass('old');
                    $('opc-payment').show();
                    $('checkout-step-payment').show();
                    jQuery('#navbar-title4').show();

                    jQuery('#navbar-step5').removeClass('active').removeClass('old');
                    $('opc-review').hide();
                    $('checkout-step-review').hide();

                    setTimeout(function () {
                        checkout.scrollTo('html');
                    });

                    break;
                case 'review':
                    jQuery('#navbar-step1').addClass('old').removeClass('active');
                    $('opc-billing').hide();
                    $('checkout-step-billing').hide();

                    jQuery('#navbar-step2').addClass('old').removeClass('active');
                    $('opc-shipping').hide();
                    $('checkout-step-shipping').hide();

                    jQuery('#navbar-step3').addClass('old').removeClass('active');
                    $('opc-shipping_method').hide();
                    $('checkout-step-shipping_method').hide();

                    jQuery('#navbar-step4').addClass('old').removeClass('active');
                    $('opc-payment').hide();
                    $('checkout-step-payment').hide();

                    jQuery('#navbar-step5').addClass('active').removeClass('old');
                    $('opc-review').show();
                    $('checkout-step-review').show();
                    jQuery('#navbar-title5').show();

                    setTimeout(function () {
                        checkout.scrollTo('html');
                    });

                    break;
            }
        },

        initLaddaButtons: function (section) {
            if (!section) return;
            var button = $$('#' + section + '-buttons-container button')[0];
            button && !button.hasClassName('ladda-button') && this.getLaddaButton(button);
        },

        allowSection: function (section) {
            // $('opc-' + section) && $('opc-' + section).addClassName('allow');
            // this.accordion.find('#checkout-step-' + section).collapse({
            //     parent: this.accordion,
            //     toggle: false
            // });
        },

        cleanList: function (section) {
            section.select('.sp-methods dt').each(function (item) {
                if (item.innerHTML.trim() == '') $(item).remove();
            });
        },

        setStepResponse: function (response) {
            if (response.update_section) {
                var sectionElm = $('checkout-' + response.update_section.name + '-load');
                sectionElm.update(response.update_section.html);
            }

            if (response.allow_sections) {
                response.allow_sections.each(function (e) {
                    this.allowSection(e);
                }.bind(this));
            }

            if (response.duplicateBillingInfo) {
                this.syncBillingShipping = true;
                try {
                    shipping.setSameAsBilling(true);
                } catch (e) {

                }
            }

            if (response.goto_section) {
                this.gotoSection(response.goto_section, true);
                return true;
            }

            if (response.redirect) {
                location.href = response.redirect;
                return true;
            }

            return false;
        },

        japiRedirect: function (id, url) {
            var btn = this.getLaddaButton($(id));
            btn && btn.start();
            setLocation(url);
        },

        gotoShippingMethodSection: function () {
            if (Ajax.activeRequestCount) {
                return setTimeout(function () {
                    this.gotoShippingMethodSection();
                }.bind(this), 100);
            }

            jQuery('#navbar-step1').addClass('old').removeClass('active');
            jQuery('#navbar-title1').hide();

            jQuery('#navbar-step2').addClass('old').removeClass('active');
            jQuery('#navbar-title2').hide();

            jQuery('#navbar-step3').addClass('active').removeClass('old');
            jQuery('#navbar-title3').show();

            jQuery('#navbar-step4').removeClass('active').removeClass('old');
            jQuery('#navbar-title4').hide();

            jQuery('#navbar-step5').removeClass('active').removeClass('old');
            jQuery('#navbar-title5').hide();

            if (typeof billing == 'undefined') return;
            var billingValidator = new Validation(billing.form);
            if (!billingValidator.validate()) return;

            /**
             * MPLUGIN-2398: Go to next step, not specific "shipping-method" step
             */
            var shippingStep;
            if (shippingStep = $('opc-shipping')) {
                var nextStep = shippingStep.next();
                if (nextStep.id && nextStep.hasClassName('section')) {
                    checkout.gotoSection(nextStep.id.replace('opc-', ''));
                    this.loadShippingMethod(this.shippingMethodUrl);
                }
            }
        },

        loadShippingMethod: function (url) {
            if (this.loadWaiting != false || !url) return;
            var additionalElm = $('onepage-checkout-shipping-method-additional-load');
            additionalElm && additionalElm.hide();
            checkout.setLoadWaiting('shipping-method');
            new Ajax.Request(url, {
                method: 'get',
                onComplete: function () {
                    checkout.setLoadWaiting(false);
                    additionalElm && additionalElm.show();
                },
                onSuccess: function (transport) {
                    billing && billing.nextStep(transport);
                }
            });
        },

        hideAllStepLabels: function () {
            jQuery('#navbar-title1').hide();
            jQuery('#navbar-title2').hide();
            jQuery('#navbar-title3').hide();
            jQuery('#navbar-title4').hide();
            jQuery('#navbar-title5').hide();
        },

        /**
         * Cancel checkout handler
         */
        cancelCheckout: function () {
            window.close();
            jQuery('#cancelCheckoutDialog').modal('hide');
            window.location.href = window.location.origin
                + window.location.pathname
                + '?jmango_continue_shopping=true';
        }
    });
}

var JMAgreement = Class.create({
    initialize: function (form) {
        this.form = form;
        this.initModals();
    },

    initModals: function () {
        this.form.select('div.modal').each(function (modal) {
            JMango(modal).find('a').click(function (e) {
                if (e.target.getAttribute('href').indexOf('#') === -1) {
                    e.preventDefault();
                }
            });
            JMango(modal).modal({
                show: false
            });
        });
    }
});

var JMDiscount = Class.create({
    initialize: function (form, saveUrl) {
        this.form = form;
        this.validator = new Validation(this.form);
        this.saveUrl = saveUrl;
        this.inputField = jQuery('#coupon_code');
        this.removeField = jQuery('#remove-coupone');
        // this.onComplete = this.resetLoadWaiting.bindAsEventListener(this);
    },

    submit: function (isRemove, button) {
        this.inputField.blur();
        if (isRemove) {
            this.removeField.value = "1";
        } else {
            this.removeField.value = "0";
        }

        if (this.validator && this.validator.validate()) {
            // checkout.setLoadWaiting($('coupon-button'));

            if (!isRemove) {
                jQuery('.coupon-form').addClass('validating');
            } else {
                jQuery(button).parent('.item-coupon').addClass('removing');
            }

            new Ajax.Request(this.saveUrl, {
                method: 'post',
                parameters: {remove: isRemove ? 1 : 0, coupon_code: this.inputField.val()},
                onSuccess: function (transport) {
                    this.resetLoadWaiting();
                    if (transport.responseJSON) {
                        var data = transport.responseJSON;
                        if (data.success && data.html) {
                            $('checkout-review-load').update(data.html);
                            checkout.initLaddaButtons('review');
                            if (isRemove) {
                                jQuery('.coupon-btn-field').show();
                            } else {
                                jQuery('.coupon-btn-field').hide();
                                jQuery('.coupon-form').removeClass('validating');
                            }
                        }
                        if (data.message) {
                            alert(data.message);
                            jQuery('.coupon-form').removeClass('validating');
                        }
                    }
                }.bind(this),
                onComplete: this.onComplete,
                onFailure: this.onComplete
            });
        }
    },

    resetLoadWaiting: function () {
        checkout.setLoadWaiting(false);
    }
});

/**
 * Override ShippingMethod.nextStep() method
 * change position of payment.initWhatIsCvvListeners() method
 */
if (typeof ShippingMethod !== 'undefined') {
    ShippingMethod.prototype.isMethodSelected = function () {
        var methods = jQuery('#checkout-shipping-method-load :input');
        var selected = false;
        if (methods && methods.length) {
            for (var i = 0; i < methods.length; i++) {
                if (methods[i].checked) {
                    selected = true;
                }
            }
        }

        if (selected) {
            jQuery('.checkoutStep3 button.submit-btn').removeAttr('disabled');
        } else {
            jQuery('.checkoutStep3 button.submit-btn').attr('disabled', 'disabled');
        }
    };

    ShippingMethod.prototype.nextStep = function (transport) {
        if (transport && transport.responseText) {
            try {
                response = eval('(' + transport.responseText + ')');
            } catch (e) {
                response = {};
            }
        }

        if (response.error) {
            /**
             * MPLUGIN-3298 : One-page checkout: Some texts are not localized in Netherland
             * Update check response error message
             */
            var error_message = response.message;
            if (error_message === 'Your order cannot be completed at this time as there is no shipping methods available for it. Please make necessary changes in your shipping address.'
                && window.location.href.indexOf('vechtsportonline.nl') > -1) {
                error_message = 'Je bestelling kan niet afgerond worden aangezien er momenteel geen verzendmethode hiervoor beschikbaar is. Maak de nodige wijzigingen in je verzendadres.';
            }
            alert(error_message);
            return false;
        }

        if (response.update_section) {
            $('checkout-' + response.update_section.name + '-load').update(response.update_section.html);
        }

        if (response.goto_section) {
            checkout.gotoSection(response.goto_section);
        }

        payment.initWhatIsCvvListeners();
    };
}

/**
 * Override Payment.initWhatIsCvvListeners() method
 * Add condition check element exist
 */
if (typeof Payment !== 'undefined') {
    Payment.prototype.isMethodSelected = function () {
        var methods = jQuery('#checkout-payment-method-load :input');
        var selected = false;
        if (methods && methods.length) {
            for (var i = 0; i < methods.length; i++) {
                if (methods[i].checked) {
                    selected = true;
                }
            }
        }

        if (selected) {
            jQuery('.checkoutStep4 button.submit-btn').removeAttr('disabled');
        } else {
            jQuery('.checkoutStep4 button.submit-btn').attr('disabled', 'disabled');
        }
    };

    Payment.prototype.initWhatIsCvvListeners = function () {
        $$('.cvv-what-is-this').each(function (element) {
            element && Event.observe(element, 'click', function (ev) {
                ev.preventDefault();
                jQuery('#payment-tool-tip-modal').modal('show');
            });
        });
    };

    Payment.prototype.nextStep = function (transport) {
        if (transport && transport.responseText) {
            try {
                response = eval('(' + transport.responseText + ')');
            } catch (e) {
                response = {};
            }
        }

        /*
         * if there is an error in payment, need to show error message
         */
        if (response.error) {
            if (response.fields) {
                var fields = response.fields.split(',');
                for (var i = 0; i < fields.length; i++) {
                    var field = null;
                    if (field = $(fields[i])) {
                        Validation.ajaxError(field, response.error);
                    }
                }
                return;
            }
            if (typeof (response.message) == 'string') {
                alert(response.message);
            } else {
                alert(response.error);
            }
            return;
        }

        if (response.redirect) {
            checkout.redirectUrl = response.redirect;
        } else {
            checkout.redirectUrl = null;
        }

        checkout.setStepResponse(response);
        //checkout.setPayment();
    };

    /**
     * Kega_Checkout: Add additional validation functions to payment step
     */
    Payment.prototype.addMoreValidateFunction = function (code, func) {
        if (!this.moreValidateFunc) this.moreValidateFunc = $H({});
        this.moreValidateFunc.set(code, func);
    };

    /**
     * Kega_Checkout: Validate additional validation functions
     */
    Payment.prototype.moreValidate = function () {
        var validateResult = true;
        if (!this.moreValidateFunc) this.moreValidateFunc = $H({});
        (this.moreValidateFunc).each(function (validate) {
            if ((validate.value)() == false) {
                validateResult = false;
            }
        }.bind(this));
        return validateResult;
    };

    /**
     * Kega_Checkout: Run additional validations
     */
    Payment.prototype.save = function () {
        if (checkout.loadWaiting != false) return;
        var validator = new Validation(this.form);
        if (this.validate() && this.moreValidate() && validator.validate()) {
            checkout.setLoadWaiting('payment');
            var request = new Ajax.Request(
                this.saveUrl,
                {
                    method: 'post',
                    onComplete: this.onComplete,
                    onSuccess: this.onSave,
                    onFailure: checkout.ajaxFailure.bind(checkout),
                    parameters: Form.serialize(this.form)
                }
            );
        }
    };
}

if (typeof Review !== 'undefined') {
    Review.prototype.isAgreed = function () {
        var agrees = jQuery('.checkout-confirmation :input.term-and-condition');
        var agreed = true;

        if (agrees && agrees.length) {
            for (var i = 0; i < agrees.length; i++) {
                if (!agrees[i].getAttribute('checked')) {
                    agreed = false;
                }
            }
        }

        if (agreed) {
            jQuery('.checkoutStep5 #submit-review').removeAttr('disabled');
        } else {
            jQuery('.checkoutStep5 #submit-review').attr('disabled', 'disabled');
        }
    };

    Review.prototype.resetLoadWaiting = function () {
        checkout.setLoadWaiting(false, this.isSuccess);
    };

    Review.prototype.addMoreValidateFunction = function (code, func) {
        if (!this.moreValidateFunc) this.moreValidateFunc = $H({});
        this.moreValidateFunc.set(code, func);
    };

    Review.prototype.moreValidate = function () {
        var validateResult = true;
        if (!this.moreValidateFunc) this.moreValidateFunc = $H({});
        (this.moreValidateFunc).each(function (validate) {
            if ((validate.value)() === false) {
                validateResult = false;
            }
        }.bind(this));
        return validateResult;
    };

    Review.prototype.addMoreFormToSubmit = function (formId) {
        if (!this.moreForms) this.moreForms = [];
        this.moreForms.push($(formId));
    };

    Review.prototype.nextStep = function (transport) {
        if (transport) {
            var response = transport.responseJSON || transport.responseText.evalJSON(true) || {};

            if (response.redirect) {
                this.isSuccess = true;
                this.emitCheckoutSuccess(response);
                location.href = encodeURI(response.redirect);
                return;
            }

            if (response.success) {
                this.isSuccess = true;
                this.emitCheckoutSuccess(response);
                location.href = encodeURI(this.successUrl);
                return;
            } else {
                var msg = response['error_messages'];
                if (Object.isArray(msg)) {
                    msg = msg.join("\n").stripTags().toString();
                }
                if (msg) {
                    alert(msg);
                }
            }

            if (response['update_section']) {
                $('checkout-' + response['update_section']['name'] + '-load').update(response['update_section']['html']);
            }

            if (response['goto_section']) {
                checkout.gotoSection(response['goto_section'], true);
            } else if (response['update_section']['name']) {
                checkout.scrollTo('#checkout-' + response['update_section']['name'] + '-load');
            }
        }
    };

    Review.prototype.emitCheckoutSuccess = function (response) {
        Event.fire(window, 'checkout:success', response);
    };
}

document.observe('dom:loaded', function () {
    if (typeof SocoShippingMethod !== 'undefined') {
        SocoShippingMethod.prototype.freezeSteps = function () {
            this.savedAllowedSteps = [];

            var steps = $('checkoutSteps').children;
            for (var i = 0; i < steps.length; i++) {
                if (steps[i].hasClassName('allow')) {
                    this.savedAllowedSteps[i] = true;
                    steps[i].hide();
                } else {
                    this.savedAllowedSteps[i] = false;
                }
            }

            /**
             * Hide default "Continue" button
             */
            $('shipping-method-buttons-container').hide();

            /**
             * Style "Annuler So Colissimo" button
             */
            var $btn = $$('#socolissimosimplicite_iframe_wrapper button')[0];
            if ($btn) {
                $btn.addClassName('ladda-button');
                $btn.setAttribute('data-size', 's');
            }
        };

        SocoShippingMethod.prototype.unfreezeSteps = function () {
            if (typeof (this.savedAllowedSteps) !== 'undefined') {
                var steps = $('checkoutSteps').children;
                for (var i = 0; i < steps.length; i++) {
                    if (this.savedAllowedSteps[i] === true) {
                        steps[i].addClassName('allow');
                    }
                }
            }

            /**
             * Show default "Continue" button
             */
            $('shipping-method-buttons-container').show();
        };
    }

    if (typeof Checkout != 'undefined' && Checkout.prototype.disallowSection) {
        Checkout.addMethods({
            setStepResponse: function (response) {
                //$$('.main-container').first().scrollTo();
                if (response.update_section) {
                    $('checkout-' + response.update_section.name + '-load').update(response.update_section.html);
                    this.assignDisallowEvent('checkout-' + response.update_section.name + '-load');
                }
                //JMANGO360: Disable product's link in cart table
                if ($$('.cart-table').length) {
                    $$('.cart-table').each(function (table) {
                        $(table).select('a').each(function (a) {
                            $(a).observe('click', function (e) {
                                e.preventDefault();
                            });
                        });
                    });
                }
                //END
                if (response.allow_sections) {
                    response.allow_sections.each(function (e) {
                        $('opc-' + e).addClassName('allow');
                    });
                }
                if (response.duplicateBillingInfo) {
                    this.syncBillingShipping = true;
                    shipping.setSameAsBilling(true);
                }
                if (response.goto_section) {
                    this.gotoSection(response.goto_section, false);
                    //JMANGO360: Apply scroll to section
                    var top = JMango('#opc-' + response.goto_section).offset().top;
                    if (typeof scrollTo == 'function') {
                        scrollTo(top);
                    } else {
                        JMango('html, body').animate({
                            scrollTop: top
                        });
                    }
                    //END
                    if (response.messages) {
                        response.messages.forEach(function (message, i) {
                            jsHelper.displayMessage(message.message, message.type);
                        });
                    }
                    return true;
                }
                if (response.redirect) {
                    location.href = response.redirect;
                    return true;
                }
                return false;
            }
        });
    }

    if (typeof Review !== "undefined") {
        /**
         * MPLUGIN-3490: Fix "js/amasty/amorderattr/payment.js" from "Amasty_Orderattr"
         */
        Review.prototype.save = function () {
            var params;

            if ($('co-directpost-form') && directPostModel && $(directPostModel.iframeId)) {
                if (directPostModel.validate()) {
                    checkout.setLoadWaiting('review');

                    params = Form.serialize(payment.form);
                    if (review.agreementsForm) {
                        params += '&' + Form.serialize(review.agreementsForm);
                    }
                    params += '&controller=onepage';

                    new Ajax.Request(directPostModel.orderSaveUrl, {
                        method: 'post',
                        parameters: params,
                        onSuccess: function () {
                            directPostModel.returnQuote();
                            Review.prototype.resetLoadWaiting();
                        },
                        onComplete: directPostModel.onSaveOnepageOrderSuccess,
                        onFailure: function (transport) {
                            this.resetLoadWaiting();
                            if (transport.status === 403) {
                                JMCheckout.prototype.ajaxFailure();
                            }
                        }
                    });
                }
            } else {
                if (checkout.loadWaiting !== false) return;

                if (!this.moreValidate()) return;

                checkout.setLoadWaiting('review');

                params = Form.serialize(payment.form);
                if (this.agreementsForm) {
                    params += '&' + Form.serialize(this.agreementsForm);
                }
                if (this.moreForms) {
                    for (var i = 0; i < this.moreForms.length; i++) {
                        params += '&' + Form.serialize(this.moreForms[i]);
                    }
                }
                if (checkout.redirectUrl) {
                    params += '&redirect=' + checkout.redirectUrl;
                }

                new Ajax.Request(this.saveUrl, {
                    method: 'post',
                    parameters: params,
                    onComplete: this.onComplete,
                    onSuccess: this.onSave,
                    onFailure: checkout.ajaxFailure.bind(checkout)
                });
            }
        };
    }
});

var JMAddress = Class.create({
    initialize: function (form, isCustomerLoggedIn, addressUrl, saveUrl, regions) {
        this.form = form;
        this.addressUrl = addressUrl;
        this.saveUrl = saveUrl;
        this.regions = regions;
        this.isCustomerLoggedIn = isCustomerLoggedIn;
    },

    /**
     * Clear and show billing form as popup
     */
    openAddressForm: function () {
        var $form = jQuery('#' + this.addressFormId);

        $form.find('input, select, textarea').each(function (i, input) {
            var $input = jQuery(input),
                name = $input.attr('name');

            if (name
                && name.indexOf('firstname') === -1
                && name.indexOf('middlename') === -1
                && name.indexOf('lastname') === -1
                && name.indexOf('country') === -1
                && name.indexOf('use_for_shipping') === -1
                && name.indexOf('save_in_address_book') === -1
            ) {
                $input.val('');
            }
        });

        jQuery('#billing\\:use_for_shipping_yes').prop('checked', true);

        this.fillSelectedCountry(
            jQuery('#' + this.addressType + '_default_country_id').val(),
            jQuery('#' + this.addressType + '_default_country_name').val()
        );

        $form.modal('show');
    },

    /**
     * Set address list from server
     *
     * @param addresses
     */
    setAddresses: function (addresses) {
        console.log('Set', this.addressesKey, addresses);
        store.set(this.addressesKey, addresses);
        this.emitAddressesChanged(addresses);
    },

    /**
     * Emit address list changed
     *
     * @param data
     */
    emitAddressesChanged: function (data) {
        Event.fire(this.form, 'store:' + this.addressesKey, data);
    },

    /**
     * Listen on address list changes
     */
    onAddressesChanged: function (addressType) {
        var addresses = store.get(this.addressesKey);

        for (var i = 0; i < addresses.length; i++) {
            if (addresses[i]['is_selected']) {
                this.selectAddress(addresses[i]);
            }
        }

        this.renderAddressList(addresses, addressType);
    },

    /**
     * Render address list
     *
     * @param addresses
     */
    renderAddressList: function (addresses, addressType) {
        if (!this.addressListContainer) return;

        var selected_address_index = 0;
        var address_index = 0;
        var has_origin_address = true;
        addresses.forEach(function (address) {
            if (address.is_selected == true) {
                selected_address_index = address_index;
            }
            if (address.is_custom) {
                has_origin_address = false;
            }
            address_index++;
        });

        /**
         * MPLUGIN-3740: Not render address list if customer doesnot has any existing address
         */
        if (!has_origin_address) return;

        if (selected_address_index != 0) {
            var temp = addresses[selected_address_index];
            addresses.splice(selected_address_index, 1);
            addresses.unshift(temp);
        }

        this.addressListContainer.innerHTML = '';
        for (var i = 0; i < addresses.length; i++) {
            var address = this.processAddressForDisplay(addresses[i]);
            if (address['is_selected']) {
                this.addressListContainer.insert({top: this.addressTemplate.evaluate(address)});
            } else {
                this.addressListContainer.insert(this.addressTemplate.evaluate(address));
            }
        }
    },

    /**
     * Prepare address data before render to html
     *
     * @param {*} address
     * @returns {*}
     */
    processAddressForDisplay: function (address) {
        if (Object.isArray(address['street'])) {
            address['street'] = address['street'].join(' ');
        }

        if (address['is_selected']) {
            address['attributes'] = 'checked';
        }

        const COUNTRY_GROUP_1 = ['US', 'AU'];
        const COUNTRY_GROUP_2 = ['CN', 'FR', 'IL'];
        const COUNTRY_GROUP_3 = ['NL', 'ES', 'IT', 'DE', 'PT', 'SE', 'DK'];

        address['address_lines'] = [];

        if (COUNTRY_GROUP_1.indexOf(address['country_id'].toUpperCase()) !== -1) {
            if (address['street'])
                address['address_lines'].push(address['street']);
            if (address['city'] || address['region'] || address['postcode'])
                address['address_lines'].push((address['city'] || '') + ' ' + (address['region'] || '') + ' ' + (address['postcode'] || ''));
            address['address_lines'].push(address['country']);
        } else if (COUNTRY_GROUP_2.indexOf(address['country_id'].toUpperCase()) !== -1) {
            if (address['street'])
                address['address_lines'].push(address['street']);
            if (address['postcode'] || address['city'] || address['region'])
                address['address_lines'].push((address['postcode'] || '') + ' ' + (address['city'] || '') + ' ' + (address['region'] || ''));
            address['address_lines'].push(address['country']);
        } else if (COUNTRY_GROUP_3.indexOf(address['country_id'].toUpperCase()) !== -1) {
            if (address['street'])
                address['address_lines'].push(address['street']);
            if (address['postcode'] || address['city'])
                address['address_lines'].push((address['postcode'] || '') + ' ' + (address['city'] || ''));
            if (address['region'])
                address['address_lines'].push(address['region']);
            address['address_lines'].push(address['country']);
        } else {
            if (address['street'])
                address['address_lines'].push(address['street']);
            if (address['city'])
                address['address_lines'].push(address['city']);
            if (address['postcode'] || address['region'])
                address['address_lines'].push((address['postcode'] || '') + ' ' + (address['region'] || ''));
            address['address_lines'].push(address['country']);
        }

        address['address_lines'] = address['address_lines'].join('<br/>');

        return address;
    },

    /**
     * Prepare address data before submit to server
     *
     * @param address
     * @return {*}
     */
    processAddressForSubmit: function (address) {
        var data = {};

        if (address['is_custom']) {
            delete address['entity_id'];
        } else {
            data[this.addressType + '_address_id'] = address['entity_id'];
        }

        for (var i in address) {
            if (address.hasOwnProperty(i)) {
                if (i === 'street') {
                    data[this.addressType + '[' + i + '][]'] = address[i];
                } else {
                    data[this.addressType + '[' + i + ']'] = address[i];
                }
            }
        }

        data['form_key'] = this.formKey;

        return data;
    },

    /**
     * Clean input id in form html
     *
     * @param id
     * @returns string
     */
    getInputName: function (id) {
        if (!id) return id;

        var regex = new RegExp('^' + this.addressType + '\\[([a-z_]+)\\]');
        var matches = id.match(regex);
        return matches ? matches[1] : '';
    },

    /**
     * Get address data from form
     *
     * @return {*}
     */
    getAddressDataForm: function () {
        var data = {},
            $form = jQuery('#' + this.addressFormId);

        if ($form.length) {
            $form.find('input, select, textarea').each(function (i, input) {
                var $input = jQuery(input),
                    inputName = this.getInputName($input.attr('name'));

                if (inputName) {
                    if (inputName === 'street') {
                        if (!data.hasOwnProperty(inputName)) {
                            data[inputName] = [];
                        }
                        data[inputName].push($input.val());
                    } else {
                        if ($input.attr('type') === 'radio') {
                            if ($input.prop('checked')) {
                                data[inputName] = $input.val();
                            }
                        } else {
                            data[inputName] = $input.val();
                        }
                    }
                }
            }.bind(this));
        }

        console.log('Form data', data);

        return data;
    },

    /**
     * Submit & save new address to local storage
     */
    saveNewAddress: function () {
        if (checkout.loadWaiting === true) return;

        var validator = new Validation(this.form);
        if (validator.validate()) {
            var address = this.getAddressDataForm();
            if (address.hasOwnProperty('firstname')) {
                address['entity_id'] = this.getUniqueID();
                address['is_custom'] = true;

                var addresses = store.get(this.addressesKey);
                addresses.push(address);
                store.add(this.addressesKey, address);
                this.selectAddress(address);
                this.emitAddressesChanged({add: address});

                //jQuery('#billing-address-details').modal('hide');

                this.save(true);
            }
        }
    },

    /**
     * Get unique string
     *
     * @return {string}
     */
    getUniqueID: function () {
        return Math.random().toString(36).substring(7);
    },

    /**
     * Set address as selected
     *
     * @param address
     */
    selectAddress: function (address) {
        var id;
        if (!address) {
            id = '0';
        } else {
            id = Object.isString(address) ? address : address.entity_id;
        }

        var addresses = store.get(this.addressesKey);
        if (addresses.length) {
            for (var i = 0; i < addresses.length; i++) {
                if (addresses[i]['entity_id'] === id) {
                    addresses[i]['is_selected'] = true;
                } else {
                    if (this.addressesKey == 'shipping_addresses' &&
                        addresses[i]['use_for_shipping'] == 1 &&
                        addresses[i]['is_custom'] == true
                    ) {
                        delete addresses[i]['use_for_shipping'];
                        addresses[i]['is_selected'] = true;
                    } else {
                        addresses[i]['is_selected'] = false;
                    }
                }
            }

            store.set(this.addressesKey, addresses, true);
        }

        this.setPrimaryButtonStatus(true);
    },

    /**
     * Set 'Next' button status
     * TRUE => Enable, FALSE => Disable
     *
     * @param {Boolean} flag
     */
    setPrimaryButtonStatus: function (flag) {
        var submitBtn = $('submit-' + this.addressType);
        if (submitBtn) {
            submitBtn.disabled = !flag;
        }
    },

    /**
     * Get selected address
     *
     * @return {*}
     */
    getSelectedAddress: function () {
        var addresses = store.get(this.addressesKey);
        if (addresses.length) {
            for (var i = 0; i < addresses.length; i++) {
                if (addresses[i]['is_selected']) {
                    return addresses[i];
                }
            }
        }
    },

    /**
     * Clear all temp addresses after checkout success
     */
    onCheckoutSuccess: function () {
        console.log('Store clear', this.addressesKey);
        store.remove(this.addressesKey);
    },

    checkRegionRequired: function () {
        var label, wildCard;
        var elements = [this.regionSelectEl, this.regionTextEl];
        var that = this;
        var regionRequired = this.config.regions_required.indexOf(this.countryEl.value) >= 0;

        elements.each(function (currentElement) {
            if (!currentElement) return;

            label = $$('label[for="' + currentElement.id + '"]')[0];
            if (label && currentElement === that.regionTextEl) {
                wildCard = label.down('em') || label.down('span.required');
                if (!that.config.show_all_regions) {
                    if (regionRequired) {
                        label.up().show();
                    } else {
                        label.up().hide();
                    }
                }
            }

            if (label && wildCard) {
                if (!regionRequired) {
                    wildCard.hide();
                    if (label.hasClassName('required')) {
                        label.removeClassName('required');
                    }
                } else if (regionRequired) {
                    wildCard.show();
                    if (!label.hasClassName('required')) {
                        label.addClassName('required');
                    }
                }
            }

            if (!regionRequired) {
                if (currentElement.hasClassName('required-entry')) {
                    currentElement.removeClassName('required-entry');
                }
            } else {
                if (!currentElement.hasClassName('required-entry')) {
                    currentElement.addClassName('required-entry');
                }
            }
        });
    },

    updateRegions: function (countryCode) {
        var container = jQuery('#opc-' + this.addressType);
        if (!container.length) return;

        container.find('#stateSelector ul').hide();

        var stateListEl = jQuery('#' + this.addressType + '-state-list-' + countryCode);
        if (stateListEl && this.regionSelectEl) {
            stateListEl.show();
            var regionId = this.regionSelectEl.getValue();
            if (regionId) {
                stateListEl.find('#option_state_' + regionId).addClass('selected');
            }
        }
    },
});

var JMBilling = Class.create(JMAddress, {
    initialize: function (form, isCustomerLoggedIn, saveUrl, regions) {
        this.form = form;
        this.validator = new Validation(this.form, {immediate: true});
        this.isCustomerLoggedIn = isCustomerLoggedIn;
        this.saveUrl = saveUrl;
        this.onSave = this.nextStep.bindAsEventListener(this);
        this.onComplete = this.resetLoadWaiting.bindAsEventListener(this);
        this.config = regions['config'];
        this.regions = regions;
        this.countryEl = $("billing:country_id");
        this.regionSelectEl = $('billing:region_id');
        this.regionTextEl = $('billing:region');

        this.addressFormId = 'billing-address-details';
        this.addressType = 'billing';
        this.addressesKey = 'billing_addresses';
        this.addressListContainer = $('billing-address-list');
        this.addressTemplate = new Template($('new-billing-address-template').innerHTML);
        this.formKey = $(this.form).down('input[name="form_key"]').getValue();

        Event.observe(this.form, 'store:' + this.addressesKey, this.onAddressesChanged.bind(this, 'billing'));
        Event.on(this.form, 'click', '.new-address-btn', this.openAddressForm.bind(this));
        Event.observe(window, 'checkout:success', this.onCheckoutSuccess.bind(this));

        var backBtn = $('billing-address-details').down('.back-btn');
        backBtn && backBtn.observe('click', function () {
            jQuery('#editBillingConfirmDialog').modal('show');
        });

        var okBtn = $('editBillingConfirmDialog').down('.btn-primary');
        var that = this;
        okBtn && okBtn.observe('click', function () {
            jQuery('#billing-address-details').modal('hide');
            jQuery('#editBillingConfirmDialog').modal('hide');
            var validator = new Validation('billing-address-form-list');
            validator.reset();
            jQuery(':input[type=text]', '#billing-address-form-list')
                .not(':button, :submit, :reset, :hidden, #billing\\:region, #billing\\:country')
                .val('')
                .prop('checked', false)
                .prop('selected', false);

            jQuery('#billing\\:firstname').val(jQuery('#billing_default_firstname').val());
            jQuery('#billing\\:lastname').val(jQuery('#billing_default_lastname').val());
            jQuery('#billing\\:country_id').val(jQuery('#billing_default_country_id').val());
            jQuery('#billing\\:country').val(jQuery('#billing_default_country_name').val());
            that.fillSelectedCountry(jQuery('#billing_default_country_id').val(), jQuery('#billing_default_country_name').val());
        });

        if (this.isCustomerLoggedIn && store.has(this.addressesKey)) {
            this.renderAddressList(store.get(this.addressesKey), 'billing');
        }

        var zipUpdater = new ZipUpdater($("billing:country_id").value, $("billing:postcode"));
        zipUpdater.update();

        this.fillSelectedCountry($('billing:country_id').getValue(), $('billing:country').getValue());
    },

    fillSelectedCountry: function (id, name) {
        jQuery('#fullscreen-select-billing-country').modal('hide');
        var countryIdInputEl = jQuery('#billing\\:country_id');
        var countryNameInputEl = jQuery('#billing\\:country');

        countryIdInputEl.val(id);
        countryNameInputEl.val(name);

        jQuery("#fullscreen-select-billing-country ul>li.selected").removeClass('selected');
        jQuery("#fullscreen-select-billing-country ul #option_country_" + id).addClass('selected');

        if (this.regions[this.countryEl.value]) {
            if (this.regionSelectEl) {
                //this.regionSelectEl.value = '';
                //this.regionSelectEl.parentElement.style.display = 'none';
            }
            if (this.regionTextEl) {
                //this.regionTextEl.parentElement.style.display = '';
                //this.regionTextEl.value = '';
                this.setMarkDisplay(this.regionTextEl, true);
            }
        } else {
            if (this.regionSelectEl) {
                //this.regionSelectEl.value = '';
                //this.regionSelectEl.parentElement.style.display = 'none';
            }
            if (this.regionTextEl) {
                //this.regionTextEl.value = '';
                //this.regionTextEl.parentElement.style.display = '';
                this.setMarkDisplay(this.regionTextEl, false);
                Validation.reset(this.regionTextEl);
            }
        }

        var zipUpdater = new ZipUpdater($("billing:country_id").value, $("billing:postcode"));
        zipUpdater.update();

        this.updateRegions(id);
        this.checkRegionRequired();

        if (typeof shipping !== "undefined"
            && !this.isCustomerLoggedIn
            && jQuery('input[name="billing[use_for_shipping]"]:checked').val() === '1'
        ) {
            shipping.fillSelectedCountry(id, name);
        }
    },

    setMarkDisplay: function (elem, display) {
        var $elm = $(elem);
        if ($elm) {
            if (display) {
                $elm.readOnly = true;
                $elm.up().addClassName('arrow-right');
            } else {
                $elm.readOnly = false;
                $elm.up().removeClassName('arrow-right');
            }
        }
    },

    fillSelectedRegion: function (id, name) {
        jQuery('#fullscreen-select-billing-state').modal('hide');
        var regionIdInputEl = jQuery('#billing\\:region_id');
        var regionNameInputEl = jQuery('#billing\\:region');

        var country_id = jQuery('#billing\\:country_id').val();

        jQuery("#fullscreen-select-billing-state ul>li.selected").removeClass('selected');
        jQuery("#fullscreen-select-billing-state #billing-state-list-" + country_id + ' #option_state_' + id).addClass('selected');

        regionIdInputEl.val(id);
        regionNameInputEl.val(name);
        fireEvent(regionNameInputEl[0], 'change');
    },

    save: function (isNewAddress) {
        if (checkout.loadWaiting !== false) return;

        if (this.isCustomerLoggedIn) {
            checkout.setLoadWaiting('billing');

            var address = this.getSelectedAddress();
            address = this.processAddressForSubmit(address);

            if (!isNewAddress) {
                delete address['billing[use_for_shipping]'];
            }

            new Ajax.Request(this.saveUrl, {
                method: 'post',
                onComplete: this.onComplete,
                onSuccess: this.onSave,
                onFailure: checkout.ajaxFailure.bind(checkout),
                parameters: address
            });
        } else {
            if (this.validator && this.validator.validate()) {
                checkout.setLoadWaiting('billing');

                new Ajax.Request(this.saveUrl, {
                    method: 'post',
                    onComplete: this.onComplete,
                    onSuccess: this.onSave,
                    onFailure: checkout.ajaxFailure.bind(checkout),
                    parameters: Form.serialize(this.form)
                });
            }
        }
    },

    resetLoadWaiting: function (transport) {
        checkout.setLoadWaiting(false);
        document.body.fire('billing-request:completed', {transport: transport});
    },

    /**
     This method recieves the AJAX response on success.
     There are 3 options: error, redirect or html with shipping options.
     */
    nextStep: function (transport) {
        var response = transport.responseJSON || transport.responseText.evalJSON(true) || {};

        if (response.error) {
            if (Object.isString(response.message)) {
                alert(response.message.stripTags().toString());
            } else {
                if (window.billingRegionUpdater) {
                    billingRegionUpdater.update();
                }

                var msg = response.message;
                if (Object.isArray(msg)) {
                    alert(msg.join("\n"));
                }
                alert(msg.stripTags().toString());
            }

            return false;
        }

        jQuery('#billing-address-details').modal('hide');

        checkout.setStepResponse(response);

        if (payment) {
            payment.initWhatIsCvvListeners();
        }
    },

    setUseForShipping: function (flag) {
        $('shipping:same_as_billing').checked = flag;
        if (flag) {
            var countryId = $('billing:country_id').getValue(),
                countryName = $('billing:country').getValue();

            shipping.fillSelectedCountry(countryId, countryName);
        }
    }
});

var JMShipping = Class.create(JMAddress, {
    initialize: function (form, isCustomerLoggedIn, saveUrl, regions) {
        this.form = form;
        this.validator = new Validation(this.form, {immediate: true});
        this.isCustomerLoggedIn = isCustomerLoggedIn;
        this.saveUrl = saveUrl;
        this.onSave = this.nextStep.bindAsEventListener(this);
        this.onComplete = this.resetLoadWaiting.bindAsEventListener(this);
        this.config = regions['config'];
        this.regions = regions;
        this.countryEl = $("shipping:country_id");
        this.regionSelectEl = $('shipping:region_id');
        this.regionTextEl = $('shipping:region');

        this.addressFormId = 'shipping-address-details';
        this.addressType = 'shipping';
        this.addressesKey = 'shipping_addresses';
        this.addressListContainer = $('shipping-address-list');
        this.addressTemplate = new Template($('new-shipping-address-template').innerHTML);
        this.formKey = $(this.form).down('input[name="form_key"]').getValue();

        Event.observe(this.form, 'store:' + this.addressesKey, this.onAddressesChanged.bind(this, 'shipping'));
        Event.on(this.form, 'click', '.new-address-btn', this.openAddressForm.bind(this));
        Event.observe(window, 'checkout:success', this.onCheckoutSuccess.bind(this));

        if (typeof billing !== "undefined") {
            Event.observe(billing.form, 'store:' + billing.addressesKey, this.onBillingAddressesChanged.bind(this));
        }

        var backBtn = $('shipping-address-details').down('.back-btn');
        backBtn && backBtn.observe('click', function () {
            jQuery('#editShippingConfirmDialog').modal('show');
        });

        var okBtn = $('editShippingConfirmDialog').down('.btn-primary');
        var that = this;
        okBtn && okBtn.observe('click', function () {
            jQuery('#shipping-address-details').modal('hide');
            jQuery('#editShippingConfirmDialog').modal('hide');
            var validator = new Validation('shipping-address-form-list');
            validator.reset();
            jQuery(':input[type=text]', '#shipping-address-form-list')
                /* .not(':button, :submit, :reset, :hidden, #shipping\\:region, #shipping\\:country') */
                .not(':button, :submit, :reset, :hidden')
                .val('')
                .prop('checked', false)
                .prop('selected', false);

            jQuery('#shipping\\:firstname').val(jQuery('#billing_default_firstname').val());
            jQuery('#shipping\\:lastname').val(jQuery('#billing_default_lastname').val());
            jQuery('#shipping\\:country_id').val(jQuery('#billing_default_country_id').val());
            jQuery('#shipping\\:country').val(jQuery('#billing_default_country_name').val());
            that.fillSelectedCountry(jQuery('#billing_default_country_id').val(), jQuery('#billing_default_country_name').val());
        });

        if (this.isCustomerLoggedIn && store.has(this.addressesKey)) {
            this.renderAddressList(store.get(this.addressesKey), 'shipping');
        }

        var zipUpdater = new ZipUpdater($("shipping:country_id").value, $("shipping:postcode"));
        zipUpdater.update();

        this.fillSelectedCountry($('shipping:country_id').getValue(), $('shipping:country').getValue());
    },

    onBillingAddressesChanged: function (ev) {
        var data = ev.memo;
        if (data && data.add) {
            var address = data.add;
            if (address['use_for_shipping'] === '1') {
                store.add(this.addressesKey, address);
                this.selectAddress(address);
                this.emitAddressesChanged();
            } else if (!this.isCustomerLoggedIn) {
                /**
                 * Always enable Shipping Next button if customer not logged in (has no address)
                 */
                this.setPrimaryButtonStatus(true);
            }
        }
    },

    fillSelectedCountry: function (id, name) {
        jQuery('#fullscreen-select-shipping-country').modal('hide');
        var countryIdInputEl = jQuery('#shipping\\:country_id');
        var countryNameInputEl = jQuery('#shipping\\:country');

        countryIdInputEl.val(id);
        countryNameInputEl.val(name);

        jQuery("#fullscreen-select-shipping-country ul>li.selected").removeClass('selected');
        jQuery("#fullscreen-select-shipping-country ul #option_country_" + id).addClass('selected');

        if (this.regions[this.countryEl.value]) {
            if (this.regionSelectEl) {
                //this.regionSelectEl.value = '';
                //this.regionSelectEl.parentElement.style.display = 'none';
            }
            if (this.regionTextEl) {
                //this.regionTextEl.parentElement.style.display = '';
                //this.regionTextEl.value = '';
                this.setMarkDisplay(this.regionTextEl, true);
            }
        } else {
            if (this.regionSelectEl) {
                //this.regionSelectEl.value = '';
                //this.regionSelectEl.parentElement.style.display = 'none';
            }
            if (this.regionTextEl) {
                //this.regionTextEl.value = '';
                //this.regionTextEl.parentElement.style.display = '';
                this.setMarkDisplay(this.regionTextEl, false);
                Validation.reset(this.regionTextEl);
            }
        }

        var zipUpdater = new ZipUpdater($("shipping:country_id").value, $("shipping:postcode"));
        zipUpdater.update();

        this.updateRegions(id);
        this.checkRegionRequired();
    },

    setMarkDisplay: function (elem, display) {
        var $elm = $(elem);
        if ($elm) {
            if (display) {
                $elm.readOnly = true;
                $elm.up().addClassName('arrow-right');
            } else {
                $elm.readOnly = false;
                $elm.up().removeClassName('arrow-right');
            }
        }
    },

    fillSelectedRegion: function (id, name) {
        jQuery('#fullscreen-select-shipping-state').modal('hide');
        var regionIdInputEl = jQuery('#shipping\\:region_id');
        var regionNameInputEl = jQuery('#shipping\\:region');

        var country_id = jQuery('#shipping\\:country_id').val();

        jQuery("#fullscreen-select-shipping-state ul>li.selected").removeClass('selected');
        jQuery("#fullscreen-select-shipping-state #shipping-state-list-" + country_id + ' #option_state_' + id).addClass('selected');

        regionIdInputEl.val(id);
        regionNameInputEl.val(name);
        fireEvent(regionNameInputEl[0], 'change');
    },

    setSameAsBilling: function (flag) {
        $('shipping:same_as_billing').checked = flag;

        if (flag) {
            this.selectAddress();
            this.syncWithBilling();
        }
    },

    syncWithBilling: function () {
        $('billing-address-select') && this.newAddress(!$('billing-address-select').value);
        $('shipping:same_as_billing').checked = true;
        if (!$('billing-address-select') || !$('billing-address-select').value) {
            arrElements = Form.getElements(this.form);
            for (var elemIndex in arrElements) {
                if (arrElements[elemIndex].id) {
                    var sourceField = $(arrElements[elemIndex].id.replace(/^shipping:/, 'billing:'));
                    if (sourceField) {
                        arrElements[elemIndex].value = sourceField.value;
                    }
                }
            }
            //$('shipping:country_id').value = $('billing:country_id').value;
            shippingRegionUpdater.update();
            $('shipping:region_id').value = $('billing:region_id').value;
            $('shipping:region').value = $('billing:region').value;
            //shippingForm.elementChildLoad($('shipping:country_id'), this.setRegionValue.bind(this));
        } else {
            $('shipping-address-select').value = $('billing-address-select').value;
        }
    },

    setRegionValue: function () {
        $('shipping:region').value = $('billing:region').value;
    },

    save: function () {
        if (checkout.loadWaiting !== false) return;

        if (this.isCustomerLoggedIn) {
            checkout.setLoadWaiting('shipping');

            var address = this.getSelectedAddress();
            if (!address && $('shipping:same_as_billing').checked === true && typeof billing !== "undefined") {
                address = billing.getSelectedAddress();
                address['same_as_billing'] = 1;
            }

            if (!address) {
                console.log('No shipping address');
                return;
            }

            address = this.processAddressForSubmit(address);

            new Ajax.Request(this.saveUrl, {
                method: 'post',
                onComplete: this.onComplete,
                onSuccess: this.onSave,
                onFailure: checkout.ajaxFailure.bind(checkout),
                parameters: address
            });
        } else {
            if (this.validator && this.validator.validate()) {
                checkout.setLoadWaiting('shipping');

                new Ajax.Request(this.saveUrl, {
                    method: 'post',
                    onComplete: this.onComplete,
                    onSuccess: this.onSave,
                    onFailure: checkout.ajaxFailure.bind(checkout),
                    parameters: Form.serialize(this.form)
                });
            }
        }
    },

    resetLoadWaiting: function () {
        checkout.setLoadWaiting(false);
    },

    nextStep: function (transport) {
        var response = transport.responseJSON || transport.responseText.evalJSON(true) || {};

        if (response.error) {
            if (Object.isString(response.message)) {
                alert(response.message.stripTags().toString());
            } else {
                if (window.shippingRegionUpdater) {
                    shippingRegionUpdater.update();
                }
                var msg = response.message;
                if (Object.isArray(msg)) {
                    alert(msg.join("\n"));
                }
                alert(msg.stripTags().toString());
            }

            return false;
        }

        jQuery('#shipping-address-details').modal('hide');

        checkout.setStepResponse(response);
    }
});
